import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { DevopsFlow } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-03-31 10:33
 */
interface DevopsFlowCU extends ConditionUtil<DevopsFlowCU>{
    ID:FieldUtil<DevopsFlowCU>;
    FLOW_NAME:FieldUtil<DevopsFlowCU>;
    REMARK:FieldUtil<DevopsFlowCU>;
    CREATE_TIME:FieldUtil<DevopsFlowCU>;
    UPDATE_TIME:FieldUtil<DevopsFlowCU>;
}

class DevopsFlowCUImpl extends ConditionUtilImpl<DevopsFlowCUImpl> implements DevopsFlowCU{ 
    newInstance(): DevopsFlowCUImpl {
        return new DevopsFlowCUImpl();
    } 
    get ID(): FieldUtil<DevopsFlowCU>{  
        return new FieldUtil('ID','id','主键', this);
    }
    get FLOW_NAME(): FieldUtil<DevopsFlowCU>{  
        return new FieldUtil('FLOW_NAME','flowName','流程名称', this);
    }
    get REMARK(): FieldUtil<DevopsFlowCU>{  
        return new FieldUtil('REMARK','remark','备注', this);
    }
    get CREATE_TIME(): FieldUtil<DevopsFlowCU>{  
        return new FieldUtil('CREATE_TIME','createTime','创健时间', this);
    }
    get UPDATE_TIME(): FieldUtil<DevopsFlowCU>{  
        return new FieldUtil('UPDATE_TIME','updateTime','更新时间', this);
    }
}

@Singleton 
class DevopsFlowMU extends TableUtilImpl<DevopsFlowCU,DevopsFlow>{ 
    tableName  = 'devops_flow';
    tableFields  = ['id','flow_name','remark','create_time','update_time'];
    modelFields  = ['id','flowName','remark','createTime','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): DevopsFlowCU {
        return new DevopsFlowCUImpl();
    }   

    static get ID(): FieldUtil<DevopsFlowCU>{ 
        return new FieldUtil('ID','id','主键', new DevopsFlowCUImpl());
    }
    static get FLOW_NAME(): FieldUtil<DevopsFlowCU>{ 
        return new FieldUtil('FLOW_NAME','flowName','流程名称', new DevopsFlowCUImpl());
    }
    static get REMARK(): FieldUtil<DevopsFlowCU>{ 
        return new FieldUtil('REMARK','remark','备注', new DevopsFlowCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<DevopsFlowCU>{ 
        return new FieldUtil('CREATE_TIME','createTime','创健时间', new DevopsFlowCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<DevopsFlowCU>{ 
        return new FieldUtil('UPDATE_TIME','updateTime','更新时间', new DevopsFlowCUImpl());
    }

    get ID(): FieldUtil<DevopsFlowCU>{ 
        return DevopsFlowMU.ID;
    }
    get FLOW_NAME(): FieldUtil<DevopsFlowCU>{ 
        return DevopsFlowMU.FLOW_NAME;
    }
    get REMARK(): FieldUtil<DevopsFlowCU>{ 
        return DevopsFlowMU.REMARK;
    }
    get CREATE_TIME(): FieldUtil<DevopsFlowCU>{ 
        return DevopsFlowMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<DevopsFlowCU>{ 
        return DevopsFlowMU.UPDATE_TIME;
    }
}
export {DevopsFlowMU, DevopsFlowCU}
